#lang racket

(define (member x l)
  (cond [(empty? l) #f]
        [else
          (define head (first l))
          (define tail (rest l))
          (cond [(equal? x head) #t]
                [else (member x tail)])]))

(require rackunit)
(check-true (member 1 (list 3 6 1)))
(check-true (member #t (list 3 #t (list))))
(check-false (member 1 (list 3 #t (list 1))))
(check-false (member #f (list)))


(define (match-prefix? pref l)
  (cond [(empty? l) #f]
        [(string-prefix? (first l) pref) #t]
        [else (match-prefix? pref (rest l))]))

(check-true (string-prefix? "Racket" "R")) ; available in standard library
(check-true (match-prefix? "R" (list "foo" "Racket")))
(check-false (match-prefix? "R" (list "foo" "bar")))
(define (list-exact-floor l)
  (cond [(empty? l) empty]
        [else
          (define new-head (exact-floor (first l)))
          (define new-list (list-exact-floor (rest l)))
          (cons new-head new-list)]))

(check-equal? 3 (exact-floor 3.14))
(check-equal?
  (list 1 2 3)
  (list-exact-floor (list 1.1 2.6 3.0)))
